package com.donaldson.engine.iot.Model;

import com.datastax.driver.core.Cluster;
import com.datastax.driver.core.ResultSet;
import com.datastax.driver.core.Row;
import com.datastax.driver.core.Session;
import com.datastax.driver.core.querybuilder.Insert;
import com.datastax.driver.core.querybuilder.QueryBuilder;
import com.datastax.driver.core.querybuilder.Select;

import java.util.ArrayList;
import java.util.List;

public class VehicleService {

    private static Cluster cluster ;

    public static List<Vehicle> getAll(){
        List<Vehicle> vehicles = new ArrayList<>();
        cluster = Cluster.builder().addContactPoints("rdcdliotpoc01.donaldson.com").build();
        Session session = cluster.connect();

        Select s = QueryBuilder.select("vehicleid", "ownerid", "description", "fueltype", "enginetype", "enginesernumber", "fuelfilterprimary",
                "fuelfiltermain", "lubefilterfullflow", "lubefilterbypass", "coolantfilter" ,"adbluefilter", "wiftype").from("poc01","vehicles");
        ResultSet resultSet = session.execute(s);

        for(Row rij : resultSet){
            Vehicle item = new Vehicle();

            item.setVehicleID(rij.getString("vehicleid"));
            item.setOwnerID(rij.getString("ownerid"));
            item.setDescription(rij.getString("description"));
            item.setFuelType(rij.getString("fueltype"));
            item.setEngineType(rij.getString("enginetype"));
            item.setEngineSerNumber(rij.getString("enginesernumber"));
            item.setFuelFilterPrimary(rij.getString("fuelfilterprimary"));
            item.setFuelFilterMain(rij.getString("fuelfiltermain"));
            item.setLubeFilterFullFlow(rij.getString("lubefilterfullflow"));
            item.setLubeFilterByPass(rij.getString("lubefilterbypass"));
            item.setCoolantFilter(rij.getString("coolantfilter"));
            item.setAdBlueFilter(rij.getString("adbluefilter"));
            item.setWIFType(rij.getString("wiftype"));
            vehicles.add(item);
        }

        session.close();

        return vehicles;
    }

    public static boolean add(Vehicle vehicle){
        cluster = Cluster.builder().addContactPoints("rdcdliotpoc01.donaldson.com").build();
        Session session = cluster.connect();

        Insert insert = QueryBuilder.insertInto("poc01","vehicles")
                .value("vehicleid", vehicle.getVehicleID())
                .value("ownerid", vehicle.getOwnerID())
                .value("description", vehicle.getDescription())
                .value("fueltype", vehicle.getFuelType())
                .value("enginetype", vehicle.getEngineType())
                .value("enginesernumber", vehicle.getEngineSerNumber())
                .value("fuelfilterprimary", vehicle.getFuelFilterPrimary())
                .value("fuelfiltermain",vehicle.getFuelFilterMain())
                .value("lubefilterfullflow",vehicle.getLubeFilterFullFlow())
                .value("lubefilterbypass",vehicle.getLubeFilterByPass())
                .value("coolantfilter",vehicle.getCoolantFilter())
                .value("adbluefilter", vehicle.getAdBlueFilter())
                .value("wiftype", vehicle.getWIFType());

        session.execute(insert);
        session.close();
        return  true;
    }

    public static Vehicle getByID(String ID){
        cluster = Cluster.builder().addContactPoints("rdcdliotpoc01.donaldson.com").build();
        Session session = cluster.connect();

        Select s = QueryBuilder.select("vehicleid", "ownerid", "description", "fueltype", "enginetype", "enginesernumber"
                , "fuelfilterprimary", "fuelfiltermain", "lubefilterfullflow", "lubefilterbypass", "coolantfilter", "adbluefilter", "wiftype")
                .from("poc01","vehicle");
        s.where(QueryBuilder.eq( "vehicleid", ID));

        Row row = session.execute(s).one();

        Vehicle vehicle = new Vehicle(row.getString("vehicleid"), row.getString("ownerid"), row.getString("description"),
                row.getString("fueltype"),row.getString("enginetype"),row.getString("enginesernumber"),
                row.getString("fuelfilterprimary"), row.getString("fuelfiltermain"), row.getString("lubefilterfullflow"),
                row.getString("lubefilterbypass"), row.getString("coolantfilter"), row.getString("adbluefilter"),
                row.getString("wiftype"));
        session.close();
        return vehicle;
    }
}
