package com.donaldson.engine.iot;

import javax.servlet.annotation.WebServlet;

import com.donaldson.engine.iot.Views.*;
import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.navigator.Navigator;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.UI;

/**
 * This UI is the application entry point. A UI may either represent a browser window 
 * (or tab) or some part of an HTML page where a Vaadin application is embedded.
 * <p>
 * The UI is initialized using {@link #init(VaadinRequest)}. This method is intended to be 
 * overridden to add component to the user interface and initialize non-component functionality.
 */
@Theme("valo")
public class MyUI extends UI {

    Navigator navigator;


    @Override
    protected void init(VaadinRequest request) {

        getPage().setTitle("Engine Liquid IoT Portal");

        navigator = new Navigator(this, this);


        navigator.addView("view1", ListExperimentsView.class);
        navigator.addView("view2", AddExperimentView.class);
        navigator.addView("EditExperimentView", EditExperimentView.class);

        navigator.addView("tracking", ShowTrackingLocation.class);
        navigator.addView("addDataSet", AddDataSetView.class);
        navigator.addView("WIF",ShowWIF.class);
        navigator.navigateTo("view1");


    }

    @WebServlet(urlPatterns = "/*", name = "MyUIServlet", asyncSupported = true)
    @VaadinServletConfiguration(ui = MyUI.class, productionMode = false)
    public static class MyUIServlet extends VaadinServlet {
    }
}
