package com.donaldson.engine.iot.Views;

import com.donaldson.engine.iot.Model.DataSet;
import com.donaldson.engine.iot.Model.DataSetService;
import com.donaldson.engine.iot.Model.ExperimentService;
import com.donaldson.engine.iot.Model.TrackingDataService;
import com.vaadin.ui.*;

import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.List;
import java.util.Set;

public class AddDataSetView extends Template {



    @Override
    protected Component Body() {
        VerticalLayout verticalLayout = new VerticalLayout();
        Panel NewDataSetDefinition = new Panel("New DataSet Definition");
        verticalLayout.addComponent(NewDataSetDefinition);

        GridLayout form = new GridLayout(4,10);
        NewDataSetDefinition.setContent(form);
        form.setWidth("100%");

        Label datasetIDLabel = new Label("Dataset ID:");
        form.addComponent(datasetIDLabel,1,0);
        form.setComponentAlignment(datasetIDLabel,Alignment.MIDDLE_RIGHT);

        TextField dataSetID = new TextField();
        form.addComponent(dataSetID,2,0);
        form.setComponentAlignment(dataSetID,Alignment.MIDDLE_CENTER);

        Label datasetIDExplication = new Label("Provide a unique name, if the test in linked to a LIMS request it " +
                "is advisable to use the test ID as this enables LIMS to retrieve it back (if this ever gets implemented)");
        form.addComponent(datasetIDExplication,3,0);
        form.setComponentAlignment(datasetIDExplication,Alignment.MIDDLE_CENTER);

        Label experimentLabel = new Label("Select the experiment to add a DataSet too");
        form.addComponent(experimentLabel,1,1);
        form.setComponentAlignment(experimentLabel,Alignment.MIDDLE_RIGHT);

        ComboBox<String> experiment = new ComboBox<>();
        List<String> experiments =ExperimentService.getAllExperimentKeys();
        experiment.setItems(experiments);
        form.addComponent(experiment,2,1);
        form.setComponentAlignment(experiment,Alignment.MIDDLE_CENTER);

        Label deviceLabel = new Label("Select a device:");
        form.addComponent(deviceLabel,1,2);
        form.setComponentAlignment(deviceLabel,Alignment.MIDDLE_RIGHT);

        ComboBox<String> Devices = new ComboBox<>();
        List<String> devices = TrackingDataService.GetAllDevices();
        Devices.setItems(devices);
        form.addComponent(Devices,2,2);
        form.setComponentAlignment(Devices,Alignment.MIDDLE_CENTER);

        Label experimentTypeLabel = new Label("Specify the type of experiment:");
        form.addComponent(experimentTypeLabel,1,3);
        form.setComponentAlignment(experimentTypeLabel,Alignment.MIDDLE_RIGHT);

        ComboBox<String> experimentType = new ComboBox<>();
        List<String> types = Arrays.asList("tracking","WIF","dP");
        experimentType.setItems(types);
        form.addComponent(experimentType,2,3);
        form.setComponentAlignment(experimentType,Alignment.MIDDLE_CENTER);

        Label experimentTypeExplication = new Label("Contact Gwen if the test you require is not in the list");
        form.addComponent(experimentTypeExplication,3,3);
        form.setComponentAlignment(experimentTypeExplication,Alignment.MIDDLE_CENTER);

        Label descriptionLabel = new Label("Explanatory description of the DataSet:");
        form.addComponent(descriptionLabel,1,4);
        form.setComponentAlignment(descriptionLabel,Alignment.MIDDLE_RIGHT);

        TextField description = new TextField();
        form.addComponent(description,2,4);
        form.setComponentAlignment(description,Alignment.MIDDLE_CENTER);

        Label testPartLabel = new Label("Monitored Part reference:");
        form.addComponent(testPartLabel,1,5);
        form.setComponentAlignment(testPartLabel,Alignment.MIDDLE_RIGHT);

        TextField testPart = new TextField();
        form.addComponent(testPart,2,5);
        form.setComponentAlignment(testPart,Alignment.MIDDLE_CENTER);

        Label starttimestampLabel = new Label("Start Timestamp:");
        form.addComponent(starttimestampLabel,1,6);
        form.setComponentAlignment(starttimestampLabel,Alignment.MIDDLE_RIGHT);

        TextField starttimestamp = new TextField("Zero will give all data available for a sensor","0");
        form.addComponent(starttimestamp,2,6);
        form.setComponentAlignment(starttimestamp,Alignment.MIDDLE_CENTER);

        Label stoptimestampLabel = new Label("Stop Timestamp:");
        form.addComponent(stoptimestampLabel,1,7);
        form.setComponentAlignment(stoptimestampLabel,Alignment.MIDDLE_RIGHT);

        TextField stoptimestamp = new TextField("leave blank if the test is not ended","blank");
        form.addComponent(stoptimestamp,2,7);
        form.setComponentAlignment(stoptimestamp,Alignment.MIDDLE_CENTER);

        Button create = new Button("Create DataSet");
        form.addComponent(create,3,9);
        form.setComponentAlignment(create,Alignment.MIDDLE_CENTER);

        create.addClickListener(new Button.ClickListener() {
            @Override
            public void buttonClick(Button.ClickEvent clickEvent) {
                DataSet dataSet = new DataSet();
                dataSet.setDatasetid(dataSetID.getValue());
                dataSet.setExperimentid( experiment.getValue());
                dataSet.setSetupid(Devices.getValue());
                dataSet.setMeasurementtype( experimentType.getValue());
                dataSet.setDescription(description.getValue());
                dataSet.setExperimentalPart(testPart.getValue());
                dataSet.setStarttimestamp(Long.parseLong(starttimestamp.getValue()));
                if (stoptimestamp.getValue() == "blank"){
                    dataSet.setStoptimestamp(null);
                }
                else {
                    dataSet.setStoptimestamp(Long.parseLong(stoptimestamp.getValue()));
                }
                DataSetService.add(dataSet);
                getUI().getNavigator().navigateTo("view1");
            }
        });

        Button cancel = new Button("Cancel");
        form.addComponent(cancel,0,9);
        form.setComponentAlignment(cancel,Alignment.MIDDLE_CENTER);

        cancel.addClickListener(new Button.ClickListener() {
            @Override
            public void buttonClick(Button.ClickEvent clickEvent) {
                getUI().getNavigator().navigateTo("view1");
            }
        });



        return verticalLayout;
    }
}
