package com.donaldson.engine.iot.Views;

import com.donaldson.engine.iot.Model.DataSet;
import com.donaldson.engine.iot.Model.DataSetService;
import com.donaldson.engine.iot.Model.Experiment;
import com.donaldson.engine.iot.Model.ExperimentService;
import com.vaadin.navigator.Navigator;
import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.ui.*;

import java.util.List;

public class EditExperimentView extends Template {

    private Navigator navigator2;

    private static TextField ExperimentID = new TextField();
    private static TextField LIMS = new TextField();
    private static TextField VehicleID = new TextField();
    private static TextField ExperimentType = new TextField();
    private static TextField Description = new TextField();
    private static Grid<DataSet> dataSetGrid = new Grid<>(DataSet.class);

    @Override
    protected Component Body() {


        navigator2 = getUI().getNavigator();

    VerticalLayout verticalLayout = new VerticalLayout();
    Panel NewExperimentDefinition = new Panel("Experiment Details");
    verticalLayout.addComponent(NewExperimentDefinition);

        NewExperimentDefinition.setSizeFull();
        GridLayout form = new GridLayout(4,8) ;
        form.setWidth("100%");
        NewExperimentDefinition.setContent(form);

        Label ExperimentIDLabel = new Label("Experiment ID:");
        form.addComponent(ExperimentIDLabel,1 , 0);
        form.setComponentAlignment(ExperimentIDLabel, Alignment.MIDDLE_RIGHT);


        form.addComponent(ExperimentID,2,0);
        form.setComponentAlignment(ExperimentID, Alignment.MIDDLE_LEFT);
        ExperimentID.setReadOnly(true);

        Label LIMSLabel = new Label("LIMS#:");
        form.addComponent(LIMSLabel,1 , 1);
        form.setComponentAlignment(LIMSLabel, Alignment.MIDDLE_RIGHT);

        LIMS.setReadOnly(true);
        form.addComponent(LIMS,2,1);
        form.setComponentAlignment(LIMS, Alignment.MIDDLE_LEFT);

        Label VehicleIDLabel = new Label("Vehicle ID:");
        form.addComponent(VehicleIDLabel,1 , 2);
        form.setComponentAlignment(VehicleIDLabel, Alignment.MIDDLE_RIGHT);


        form.addComponent(VehicleID,2,2);
        form.setComponentAlignment(VehicleID, Alignment.MIDDLE_LEFT);

        Label ExperimentTypeLabel = new Label("Experiment Type:");
        form.addComponent(ExperimentTypeLabel,1 , 3);
        form.setComponentAlignment(ExperimentTypeLabel, Alignment.MIDDLE_RIGHT);


        form.addComponent(ExperimentType,2,3);
        form.setComponentAlignment(ExperimentType, Alignment.MIDDLE_LEFT);

        Label DescriptionLabel = new Label("Description:");
        form.addComponent(DescriptionLabel,1 , 4);
        form.setComponentAlignment(DescriptionLabel, Alignment.MIDDLE_RIGHT);


        form.addComponent(Description,2,4);
        form.setComponentAlignment(Description, Alignment.MIDDLE_LEFT);

        form.addComponent(dataSetGrid,0,6,3,6);
        dataSetGrid.setSizeUndefined();

        /*dataSetGrid.addItemClickListener(
                event ->
                 navigator.navigateTo((event.getItem()).getMeasurementtype() + "/" + ((DataSet)(event.getItem())).getDatasetid()));
        */
        dataSetGrid.addItemClickListener(event -> {
            DataSet item = event.getItem();
            String type = item.getMeasurementtype();
            String id = item.getDatasetid();
            String destination = type + "/" + id;

            navigator2.navigateTo(destination);
        });


        Button create = new Button("Update Experiment");
        form.addComponent(create,3,7);
        form.setComponentAlignment(create,Alignment.MIDDLE_CENTER);

        create.addClickListener(new Button.ClickListener() {
            @Override
            public void buttonClick(Button.ClickEvent clickEvent) {
                Experiment experiment = new Experiment();
                experiment.setExperimentid(ExperimentID.getValue());
                experiment.setLIMS(LIMS.getValue());
                experiment.setVehicleid(VehicleID.getValue());
                experiment.setExperimentType(ExperimentType.getValue());
                experiment.setDescription(Description.getValue());

                ExperimentService.Add(experiment);
                navigator2.navigateTo("view1");
            }
        });



        Button cancel = new Button("Cancel");
        form.addComponent(cancel,0,7);
        form.setComponentAlignment(cancel,Alignment.MIDDLE_CENTER);

        cancel.addClickListener(new Button.ClickListener() {
            @Override
            public void buttonClick(Button.ClickEvent clickEvent) {
                navigator2.navigateTo("view1");
            }
        });
        return verticalLayout;
    }

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
        if(event.getParameters() != null){
            // split at "/", add each part as a label
            String[] msgs = event.getParameters().split("/");
            for (String msg : msgs) {
                Experiment experiment = ExperimentService.getByID(msg);
                ExperimentID.setValue(experiment.getExperimentid());
                ExperimentType.setValue(experiment.getExperimentType());
                LIMS.setValue(experiment.getLIMS());
                VehicleID.setValue(experiment.getVehicleid());
                Description.setValue(experiment.getDescription());
                List<DataSet> dataSets = DataSetService.getByExperimentID(msg);
                dataSetGrid.setItems(dataSets);

                dataSetGrid.setWidth("100%");
            }
        }
    }


}