package com.donaldson.engine.iot.Views;

import com.donaldson.engine.iot.Model.*;
import com.vaadin.navigator.ViewChangeListener;
//import com.vaadin.tapio.googlemaps.GoogleMap;
//import com.vaadin.tapio.googlemaps.client.LatLon;
import com.vaadin.ui.*;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ShowTrackingLocation  extends Template {

    private static Label Device = new Label();
    private static Label Dataset = new Label();
    private static Label Timestamp = new Label();
    private static Label Lattitude = new Label();
    private static Label Longitude = new Label();
    private static Label Altitude = new Label();
    private static Label Temperature = new Label();
    private static Label batteryLevel= new Label();
    //private static GoogleMap googleMap = new GoogleMap("AIzaSyAXUMoKyDQxBDwga50t-aoWlADHvSsXaJg", null, "english");

    @Override
    protected Component Body() {

        VerticalLayout verticalLayout = new VerticalLayout();
        Panel ActualTrackingDetails = new Panel("Actual Tracking Details");
        verticalLayout.addComponent(ActualTrackingDetails);

        ActualTrackingDetails.setSizeFull();
        GridLayout form = new GridLayout(5,8) ;
        form.setWidth("100%");
        ActualTrackingDetails.setContent(form);

        Label DatasetLabel = new Label("Data Set ID: ");
        form.addComponent(DatasetLabel,0,0);
        form.setComponentAlignment (DatasetLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Dataset,1,0);
        form.setComponentAlignment(Dataset,Alignment.MIDDLE_LEFT);

        Label DeviceLabel = new Label("Device: ");
        form.addComponent(DeviceLabel,0,1);
        form.setComponentAlignment(DeviceLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Device,1,1);
        form.setComponentAlignment(Device,Alignment.MIDDLE_LEFT);

        Label TimestampLabel = new Label("Last Timestamp: ");
        form.addComponent(TimestampLabel,0,2);
        form.setComponentAlignment(TimestampLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Timestamp, 1,2);
        form.setComponentAlignment(Timestamp, Alignment.MIDDLE_LEFT);

        Label TemperatureLabel = new Label("Actual module Temperature: ");
        form.addComponent(TemperatureLabel,0,3);
        form.setComponentAlignment(TemperatureLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Temperature,1,3);
        form.setComponentAlignment(Temperature,Alignment.MIDDLE_LEFT);

        Label BatteryLabel = new Label("Battery Level: ");
        form.addComponent(BatteryLabel,0,4);
        form.setComponentAlignment(BatteryLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(batteryLevel,1,4);
        form.setComponentAlignment(batteryLevel,Alignment.MIDDLE_LEFT);

        Label LattitudeLabel = new Label("Lattitude: ");
        form.addComponent(LattitudeLabel,0,5);
        form.setComponentAlignment(LattitudeLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Lattitude,1,5);
        form.setComponentAlignment(Lattitude,Alignment.MIDDLE_LEFT);

        Label LongitudeLabel = new Label("Longitude: ");
        form.addComponent(LongitudeLabel,0,6);
        form.setComponentAlignment(LongitudeLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Longitude,1,6);
        form.setComponentAlignment(Longitude,Alignment.MIDDLE_LEFT);

        Label AltitudeLabel = new Label("Altitude: ");
        form.addComponent(AltitudeLabel,0,7);
        form.setComponentAlignment(AltitudeLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Altitude,1,7);
        form.setComponentAlignment(Altitude,Alignment.MIDDLE_LEFT);

        /*form.addComponent(googleMap,2,0,4,7);
        googleMap.setSizeFull();
        googleMap.setZoom(18);*/

        return verticalLayout;
    }

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
        if(event.getParameters() != null){
            // split at "/", add each part as a label
            String[] msgs = event.getParameters().split("/");
            String msg = msgs[0];

            TrackingData trackingData = TrackingDataService.getLastFromDatasetID(msg);
            Dataset.setValue(msg);
            Device.setValue(trackingData.getDevice());
            Date date = new Date ();

            date.setTime(trackingData.getTimestamp()*1000);
            DateFormat df2 = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");
            Timestamp.setValue(df2.format(date));

            Float temp = trackingData.getTemperature();
            Temperature.setValue(temp.toString()+"°C");
            batteryLevel.setValue(((Integer)trackingData.getBatteryLevel()).toString()+"%");
            /*LatLon location = new LatLon(trackingData.getLattitude(),trackingData.getLongitude());
            googleMap.addMarker("Last Location", location, true,null);
            googleMap.setCenter(location);*/
            Double lat = trackingData.getLattitude();
            Lattitude.setValue(lat.toString()+"°");
            Double lon = trackingData.getLongitude();
            Longitude.setValue(lon.toString()+"°");
            Altitude.setValue(trackingData.getAltitude().toString()+" m");
        }
    }
}
