package com.donaldson.engine.iot.Views;

import com.donaldson.engine.iot.Model.TrackingData;
import com.donaldson.engine.iot.Model.TrackingDataService;
import com.donaldson.engine.iot.Model.WIFData;
import com.donaldson.engine.iot.Model.WIFDataService;
import com.vaadin.navigator.ViewChangeListener;
//import com.vaadin.tapio.googlemaps.GoogleMap;
//import com.vaadin.tapio.googlemaps.client.LatLon;
import com.vaadin.ui.*;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ShowWIF extends Template {

    private static Label Device = new Label();
    private static Label Dataset = new Label();
    private static Label Timestamp = new Label();
    private static Label Lattitude = new Label();
    private static Label Longitude = new Label();
    private static Label Altitude = new Label();
    private static Label Temperature = new Label();
    private static Label batteryLevel= new Label();
    private static Label WIF = new Label();
    //private static GoogleMap googleMap = new GoogleMap("AIzaSyAXUMoKyDQxBDwga50t-aoWlADHvSsXaJg", null, "english");

    @Override
    protected Component Body() {

        VerticalLayout verticalLayout = new VerticalLayout();
        HorizontalLayout overview = new HorizontalLayout();
        verticalLayout.addComponent(overview);

        Panel ActualTrackingDetails = new Panel("Actual WIF Tracking Details");
        overview.addComponent(ActualTrackingDetails);
        ActualTrackingDetails.setWidth("500px");

        ActualTrackingDetails.setWidth("55%");
        GridLayout form = new GridLayout(5,9) ;
        form.setWidth("500px");
        ActualTrackingDetails.setContent(form);

        Label DatasetLabel = new Label("Data Set ID: ");
        form.addComponent(DatasetLabel,0,0);
        form.setComponentAlignment (DatasetLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Dataset,1,0);
        form.setComponentAlignment(Dataset,Alignment.MIDDLE_CENTER);

        Label DeviceLabel = new Label("Device: ");
        form.addComponent(DeviceLabel,0,1);
        form.setComponentAlignment(DeviceLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Device,1,1);
        form.setComponentAlignment(Device,Alignment.MIDDLE_CENTER);

        Label WIFLabel = new Label("WIF signal Actual reading:");
        form.addComponent(WIFLabel,0,2);
        form.setComponentAlignment(WIFLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(WIF,1,2);
        form.setComponentAlignment(WIF,Alignment.MIDDLE_CENTER);

        Label TimestampLabel = new Label("Last Timestamp: ");
        form.addComponent(TimestampLabel,0,3);
        form.setComponentAlignment(TimestampLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Timestamp, 1,3);
        form.setComponentAlignment(Timestamp, Alignment.MIDDLE_CENTER);

        Label TemperatureLabel = new Label("Actual module Temperature: ");
        form.addComponent(TemperatureLabel,0,4);
        form.setComponentAlignment(TemperatureLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Temperature,1,4);
        form.setComponentAlignment(Temperature,Alignment.MIDDLE_CENTER);

        Label BatteryLabel = new Label("Battery Level: ");
        form.addComponent(BatteryLabel,0,5);
        form.setComponentAlignment(BatteryLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(batteryLevel,1,5);
        form.setComponentAlignment(batteryLevel,Alignment.MIDDLE_CENTER);

        Label LattitudeLabel = new Label("Lattitude: ");
        form.addComponent(LattitudeLabel,0,6);
        form.setComponentAlignment(LattitudeLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Lattitude,1,6);
        form.setComponentAlignment(Lattitude,Alignment.MIDDLE_CENTER);

        Label LongitudeLabel = new Label("Longitude: ");
        form.addComponent(LongitudeLabel,0,7);
        form.setComponentAlignment(LongitudeLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Longitude,1,7);
        form.setComponentAlignment(Longitude,Alignment.MIDDLE_CENTER);

        Label AltitudeLabel = new Label("Altitude: ");
        form.addComponent(AltitudeLabel,0,8);
        form.setComponentAlignment(AltitudeLabel,Alignment.MIDDLE_RIGHT);
        form.addComponent(Altitude,1,8);
        form.setComponentAlignment(Altitude,Alignment.MIDDLE_CENTER);

        /*
        overview.addComponent(googleMap);
        googleMap.setWidth("600px");
        googleMap.setHeight("400px");
        googleMap.setZoom(16);
        */

        return verticalLayout;
    }

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
        if(event.getParameters() != null){
            // split at "/", add each part as a label
            String[] msgs = event.getParameters().split("/");
            String msg = msgs[0];

            WIFData trackingData = WIFDataService.getLastFromDatasetID(msg);
            Dataset.setValue(msg);
            Device.setValue(trackingData.getDevice());
            Date date = new Date ();
            date.setTime(trackingData.getTimestamp()*1000);
            DateFormat df2 = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");
            Timestamp.setValue(df2.format(date));
            Float temp = trackingData.getTemperature();
            Temperature.setValue(temp.toString()+"°C");
            batteryLevel.setValue(((Integer)trackingData.getBatteryLevel()).toString()+"%");
            /*
            LatLon location = new LatLon(trackingData.getLattitude(),trackingData.getLongitude());
            googleMap.addMarker("Last Location", location, true,null);
            googleMap.setCenter(location);
            */
            Double lat = trackingData.getLattitude();
            Lattitude.setValue(lat.toString()+"°");
            Double lon = trackingData.getLongitude();
            Longitude.setValue(lon.toString()+"°");
            Altitude.setValue(trackingData.getAltitude().toString());
            WIF.setValue(trackingData.getWIF().toString());
        }
    }
}
